/*
MSc IT DBIS Application
Monica Farrow
(Adapted from a similar class in Core Java by Horstmann)
A dialog box to obtain type of database,username and password,
*/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

class UserPassDialog extends JDialog
						implements ActionListener
{
	private JTextField username;
	private JPasswordField password;
	private JComboBox dbasetype;
	private JTextField dbaseodbc;
	private JButton okButton;
	private String dt;
	
	public UserPassDialog(JFrame parent)
	{
		super(parent, "Log on", true);
		setSize(240,240);
	
		//panel for username and password text fields
		JPanel userpassPanel = new JPanel();
		userpassPanel.setLayout(new GridLayout(4,2));
		dbasetype = new JComboBox();
		dbasetype.addItem("");
		dbasetype.addItem("Oracle");
		dbasetype.addItem("Access");
		dbasetype.addActionListener(this);
		userpassPanel.add(new JLabel("Database Type:"));
		userpassPanel.add(dbasetype );
		
		userpassPanel.add(new JLabel("User name:"));
		userpassPanel.add(username = new JTextField(""));
		username.setEditable(false);
		
		userpassPanel.add(new JLabel("Password:"));
		userpassPanel.add(password = new JPasswordField(""));
		password.setEditable(false);
		password.setBackground(Color.lightGray);
		
		userpassPanel.add(new JLabel("ODBC name:"));
		userpassPanel.add(dbaseodbc = new JTextField(""));
		dbaseodbc.setEditable(false);
		
		getContentPane().add("Center",userpassPanel);
		
		//Panel for button
		Panel pOK = new Panel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		pOK.add(okButton);	
		getContentPane().add("South",pOK);
		

	}
	
	//come here when OK button clicked
	public void actionPerformed(ActionEvent e)
	{
		Object source = e.getSource();
		if (source == okButton)
		{
			setVisible(false);
		}
		if (source == dbasetype)
		{
			dt = (String)dbasetype.getSelectedItem();
			if (dt.equals("Oracle"))
			{
				username.setEditable(true);
				password.setEditable(true);
				dbaseodbc.setEditable(false);
				password.setBackground(Color.white);
			}
			else if  (dt.equals("Access"))
			{
				username.setEditable(false);
				password.setEditable(false);
				dbaseodbc.setEditable(true);
			}
		}
	}
	
	//show Dialog
	public LogOn showDialog()
	{
		this.show();
		String un = username.getText();
		String pw = new String (password.getPassword());
		String dod = dbaseodbc.getText();
		return new LogOn(un,pw,dt,dod);
	}
		
}
		
			

	